
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class LayersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const layers = await db.layers.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        layer_type: data.layer_type
        ||
        null
            ,
            
        props: data.props
        ||
        null
            ,
            
        order: data.order
        ||
        null
            ,
            
        visible: data.visible
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await layers.setPage( data.page || null, {
            transaction,
        });
        
        await layers.setParent( data.parent || null, {
            transaction,
        });
        
        await layers.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return layers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const layersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                layer_type: item.layer_type
            ||
            null
            ,
            
                props: item.props
            ||
            null
            ,
            
                order: item.order
            ||
            null
            ,
            
                visible: item.visible
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const layers = await db.layers.bulkCreate(layersData, { transaction });

        // For each item created, replace relation files
        

        return layers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const layers = await db.layers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.layer_type !== undefined) updatePayload.layer_type = data.layer_type;
        
        
        if (data.props !== undefined) updatePayload.props = data.props;
        
        
        if (data.order !== undefined) updatePayload.order = data.order;
        
        
        if (data.visible !== undefined) updatePayload.visible = data.visible;
        
        
        updatePayload.updatedById = currentUser.id;

        await layers.update(updatePayload, {transaction});

        
        
        if (data.page !== undefined) {
            await layers.setPage(
              
              data.page,
              
              { transaction }
            );
        }
        
        if (data.parent !== undefined) {
            await layers.setParent(
              
              data.parent,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await layers.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return layers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const layers = await db.layers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of layers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of layers) {
                await record.destroy({transaction});
            }
        });


        return layers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const layers = await db.layers.findByPk(id, options);

        await layers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await layers.destroy({
            transaction
        });

        return layers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const layers = await db.layers.findOne(
            { where },
            { transaction },
        );

        if (!layers) {
            return layers;
        }

        const output = layers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.page = await layers.getPage({
            transaction
        });
        
        
        output.parent = await layers.getParent({
            transaction
        });
        
        
        output.organizations = await layers.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.pages,
        as: 'page',
        
        where: filter.page ? {
          [Op.or]: [
            { id: { [Op.in]: filter.page.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.page.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.layers,
        as: 'parent',
        
        where: filter.parent ? {
          [Op.or]: [
            { id: { [Op.in]: filter.parent.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.parent.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'layers',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.props) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'layers',
                        'props',
                        filter.props,
                    ),
                };
            }
            

            
            

            
            if (filter.orderRange) {
                const [start, end] = filter.orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    order: {
                    ...where.order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    order: {
                    ...where.order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.layer_type) {
                where = {
                    ...where,
                layer_type: filter.layer_type,
            };
            }
            
            if (filter.visible) {
                where = {
                    ...where,
                visible: filter.visible,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.layers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'layers',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.layers.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

